#ifndef ENCODER_H
#define ENCODER_H

#include "mbed.h"

struct EncoderData
{
    PinName encAPin, encBPin;
    int turnCount;
};

class Encoder
{
public:
    Encoder(EncoderData nData);
    
    virtual void reset();
    
    long getCount() const;
    float getTurn() const;
    
protected:
    EncoderData data;
    
private:
    void changeA();
    void changeB();
    void changeCount(bool flipB);
    
    InterruptIn intA, intB;
    volatile bool valA, valB;
    
    volatile long count;
};

#endif // ENCODER_H