#ifndef PID_CONTROLLER_H
#define PID_CONTROLLER_H

#include "ErrorController.hpp"
#include "mbed.h"

struct PIDData
{
    float Kp, Ki, Kd;
};

class PIDController : public ErrorController
{
public:
    PIDController(PIDData nData);
    virtual ~PIDController();

    virtual void reset();
    virtual float step(float error);

    void set(PIDData nData);

protected:
    PIDData data;

private:
    Timer timer;

    float prev_error;
    float integral;
};

#endif // PID_CONTROLLER_H