#include "SpeedEncoder.hpp"

SpeedEncoder::SpeedEncoder(EncoderData nData) :
    Encoder(nData), prevCount(0)
{
    timer.start();
}

void SpeedEncoder::reset()
{
    Encoder::reset();
    prevCount = 0; // TODO: calculate shift
}

float SpeedEncoder::getCountSpeed()
{
    long count = getCount();
    long dCount = count - prevCount;
    
    float speed = dCount / timer.read();
    timer.reset(); // timer keeps running
    
    prevCount = count;
    return speed;
}

float SpeedEncoder::getTurnSpeed()
{
    return getCountSpeed() / data.turnCount;
}